package parser;

import java.util.Vector;

public class BasicOperation implements Operation {
 protected int pos;
 protected int typ;

 protected BasicOperation(int pos, int typ) {
  this.typ = typ;
  this.pos = pos;
 }

 public Node[] devideAndCreate(String string) {
  Node[] nodes = new Node[2];
  nodes[0] = NodeFactory.newInstance(string.substring(0, pos));
  nodes[1] = NodeFactory.newInstance(string.substring(pos+1));
  return nodes;
 }

 public double link(Node[] nodes, Vector variables) {
  switch (typ) {
   case PLUS:
    return nodes[0].getValue(variables) + nodes[1].getValue(variables);
   case MINUS:
    return nodes[0].getValue(variables) - nodes[1].getValue(variables);
   case MULTIPLICATION:
    return nodes[0].getValue(variables) * nodes[1].getValue(variables);
   case DIVISION:
    return nodes[0].getValue(variables) / nodes[1].getValue(variables);
   case POWER:
    return tool.Utils.pow(nodes[0].getValue(variables), nodes[1].getValue(variables));
  }
  throw new RuntimeException(" : "+typ);
 }

}
