package parser;

import java.util.Vector;
import java.lang.Math;
import tool.Locale;

public class PostfixOperation implements Operation {

 protected int typ;
 public static boolean rad = true;

 public PostfixOperation(int typ) {
  this.typ = typ;
 }

 public Node[] devideAndCreate(String string) {
  Node[] nodes = new Node[1];
  switch ( typ ) {
   case LN:
    nodes[0] = NodeFactory.newInstance(string.substring(3, string.length()-1));
    break;
   case EXP:
   case SIN:
   case COS:
   case TAN:
   case ABS:
    nodes[0] = NodeFactory.newInstance(string.substring(4, string.length()-1));
   break;
   case ASIN:
   case ACOS:
   case ATAN:
   case SQRT:
    nodes[0] = NodeFactory.newInstance(string.substring(5, string.length()-1));
   break;
  }
  return nodes;
 }

 public double link(Node[] nodes, Vector variables) {
  switch ( typ ) {
   case LN:
    return tool.Utils.ln(nodes[0].getValue(variables));
   case EXP:
    return tool.Utils.exp(nodes[0].getValue(variables));
   case SIN:
    if (rad)
     return Math.sin(nodes[0].getValue(variables));
    else
     return Math.sin(nodes[0].getValue(variables)*Math.PI/180);
   case COS:
    if (rad)
     return Math.cos(nodes[0].getValue(variables));
    else
     return Math.cos(nodes[0].getValue(variables)*Math.PI/180);
   case TAN:
    if(rad)
     return Math.tan(nodes[0].getValue(variables));
    else
     return Math.tan(nodes[0].getValue(variables)*Math.PI/180);
   case ABS:
    return Math.abs(nodes[0].getValue(variables));
/*
   case ASIN:
    return Math.asin(nodes[0].getValue(variables));
   case ACOS:
    return Math.acos(nodes[0].getValue(variables));
   case ATAN:
    return Math.atan(nodes[0].getValue(variables));
*/
   case SQRT:
    return Math.sqrt(nodes[0].getValue(variables));
  }
  throw new RuntimeException(Locale.BadType+typ);
 }

}
